# FireWorks CSUMS Spring 2013 A. O. Hausknecht 
from visual import *
from visual.graph import *
import random
# Create the scene
scene1 = display(title='Fireworks', x=0, y=0, width=700, height=700, center=(0,0,4))
scene1.range = 200
#
class Willow(object):
    """A class to simulate a willow firecracker."""
    def __init__(self, t0, x0, y0, n):
        self.t0 = t0; self.p0 = vector(x0, y0, 0)
        self.a0 = vector(0, -32, 0)
        self.ballsHidden = True;  balls = []
        colors = [color.red,     color.green, color.blue,  color.yellow,
                  color.magenta, color.cyan,  color.white, color.orange]
        for i in range(n): 
            c = colors[i % 8]
            b = sphere(pos = self.p0, radius = 0.5, color = c , visible = False,
                       make_trail=True, trail_type="points", retain=0)
            b.make_trail=False
            angle = radians(random.randrange(30, 150))   # Random velocity angle
            b.v0 = vector(cos(angle), sin(angle), 0)*60  # Random velocity
            balls.append(b)
        self.balls = balls
        self.rocket = arrow(pos = (x0, y0-32, 0), axis = (0, 4, 0), 
                        color = color.white, make_trail=True,trail_type="points")

    def move(self, t):
        """The function 'Move' moves all the firework parts."""
        t -= self.t0+2
        if (t<0): # Launch the firecracker
            p0 = self.p0
            self.rocket.pos = vector(p0.x, 16*t+p0.y,0)
        elif self.ballsHidden and t>=0: # Show the firecracker parts
            for b in self.balls:
                b.visible = True
                b.make_trail = True; b.retain = 100
                b.trail_object.color = b.color
            self.ballsHidden = False               
        elif t<6: # Move firecracker parts via the equation of motion near earth
            for b in self.balls:
                b.pos = self.p0+ b.v0*t+self.a0*(t**2)/2.0


# Create the mouse click callback and bind it to the scene
def showFireWorks(evt):
    """Creates a new firecracker at point of mouse click"""
    global fireworks
    fireworks.append(Willow(t, evt.pos.x, evt.pos.y, 50))
    
scene1.bind('click', showFireWorks)

#Initialize
#
## 1. Create the moon
moonData = materials.loadTGA("moon256x256.tga")
tex = materials.texture(data=moonData, mapping="sign", interpolate=False)     
moon = sphere(pos = (50,50,-50), radius= 50, axis=(0,0,1), 
              color = color.black, material=tex)      
## 2. Create the global variables
fireworks=[] 
t = 0; dt = 0.1

#Annimation Loop
while True:
    rate(20)
    t += dt        
    for f in fireworks:
        f.move(t)
        
    
 
     
